#include <iostream>
#include <cstdlib>
#include "Time.h"

using namespace std;

// Time class implementation

// Constructors
Time::Time()
{
	tt = new struct _time;
        cout << "constructor " << endl;
}

Time::Time(int h, int m, int s)
{
	tt = new struct _time;
	// Assign values, but check for input errors
	if ( (h < 0) || (h > 23) ) {
		cout << "Hours value " << h << " is out of the range [0,23].\n";
		exit (0);
	}
	else {
		tt->hour = h;
	}

	if ( (m < 0) || (m > 59) ) {
		cout << "Minutes value " << m << " is out of the range [0,59].\n";
		exit (0);
	}
	else {
		tt->minute = m;
	}
     
	if ( (s < 0) || (s > 59) ) {
		cout << "Seconds value " << s << " is out of the range [0,59].\n";
		exit (0);
	}
	else {
		tt->second = s;
	}
	 cout << "constructor " << endl;
}

Time::Time(const Time &t)
{
	tt = new struct _time;
	*tt = *t.tt;
	 cout << "copy constructor " << endl;
}

Time::~Time()
{
	cout << "destructor " << endl;
	delete tt;
}

Time &
Time::operator=(const Time & t)
{
	*tt = *t.tt;
	cout << "assignment " << endl;
	return (*this);
}

// Operator overload functions
Time Time::operator+(Time & t)
{
	// Calculate the total seconds in each object,
	// add them up, then convert back
	int TotalTime;
	Time sum;

	TotalTime = tt->second + 60*tt->minute + 3600*tt->hour;
	TotalTime += t.tt->second + 60*t.tt->minute + 3600*t.tt->hour;

	// Division here is integer division
	sum.tt->hour = TotalTime/3600;
	sum.tt->minute = (TotalTime - 3600*sum.tt->hour)/60;
	sum.tt->second = TotalTime%60;
    
	return (sum);
}

Time Time::operator-(Time & t)
{
	// Calculate the total seconds in each object,
	// subtract, then convert back
	int TotalTime;
	Time sum;

	TotalTime = tt->second + 60*tt->minute + 3600*tt->hour;
	TotalTime -= t.tt->second + 60*t.tt->minute + 3600*t.tt->hour;

	// Division here is integer division
	sum.tt->hour = TotalTime/3600;
	sum.tt->minute = (TotalTime - 3600*sum.tt->hour)/60;
	sum.tt->second = TotalTime%60;
   
	return (sum);
}

// Other functions
void Time::AddtoTime(int h, int m, int s)
{
	// Add to values
	Time temp(h,m,s);
	(*this) = (*this) + temp;
}

void Time::Print()
{
	cout << "(" << tt->hour << ", " << tt->minute << ", " << tt->second << ")\n";
}


